#include "dos.h"
#include <math.h>
#include <stdio.h>
#include <conio.h>
#include ".\dgg.h"
#include ".\dgg.c"
#include ".\dgk.c"
#include ".\dgs.c"
#include ".\dgmachine.c"
#include ".\dgt.c"
#include ".\dgtext.c"
#include ".\dgf.c"

void loadlevel(char *sprite[MAXB], char level[LHIGHT][LWIDTH]){

     int i=0,j=0,x=0,y=0;

     for(j=0;j<LHIGHT;j++){
      for(i=0;i<LWIDTH;i++){
       putblock(sprite[level[j][i]],x, y);
       x+=WIDTH;
      }
      y+=HIGHT;
      x=0;
     }
}

void loadlevels(char level[LHIGHT][LWIDTH]){

     int i=0,j=0,x=0,y=0;

     for(j=0;j<LHIGHT;j++){
      for(i=0;i<LWIDTH;i++){
      if(level[j][i])
       killsprite(level[j][i],x,y);
       x+=WIDTH;
      }
      y+=HIGHT;
      x=0;
     }
}

void showpallete(void){
      int i=0,j=0,c;

      for(c=0;c<256;c++){
       killsprite(c,i,j);
       if(i>305){ i=0; j+=12;}
       else i+=7;
#ifdef DBG
printf("%d",i);
#endif
      }
}

int main(void)
{
 int x,y,quit=0,pause=0,temp,jump=0,fall=0;
 int oldx=0,oldy=0;
 int i=0;
 int j=0;
 int left=0, dead=0;
 int mx,my,ms=0,mdelay=0;
// int fathd=0, faths=0, fx=0, fy=0;
 int dinod=0, dinos=0;

int    fall_delay=0;
int    jump_delay=5;
int    dead_delay=0;
char keyme;


int  acids[MACIDS][4]={{0,0,42,156},
		       {0,0,49,156},
		       {0,0,56,156},
		       {0,0,63,156},
		       {0,0,70,156},
		       {0,0,77,156},
		       {0,0,84,156},
		       {0,0,91,156},
		       {0,0,98,156},
		       {0,0,105,156},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0},
		       {-1,0,0,0}};


int  dspikes[MSPIKE][4]={{0,0,104,120},
			 {0,0,70,60},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0},
			 {-1,0,0,0}};



int  fathos[MFATH][4]={{-1,0,203,156},
		       {-1,0,70,60},
		       {-1,0,56,156},
		       {-1,0,63,156},
		       {0,0,203,156}};

int  yipis[MYIPI][4]={{0,0,196,156},
		      {-1,0,70,60},
		      {-1,0,56,156},
		      {-1,0,63,156},
		      {-1,0,70,156}};


char dude[HIGHT][WIDTH]={{17,12,12,12,17,17,17},
			 { 8,12,12,12,12,12,17},
			 {91,91,91, 9,91,17,17},
			 {17,91,91,91,17,17,17},
			 {17,91,17,17,17,17,17},
			 {17,04,12,17,23,23,23},
			 {17,12,04,91,24,17,17},
			 {17,34,34,17,17,17,17},
			 {17,34,34,17,17,17,17},
			 {17,34,17,17,17,17,17},
			 {17, 6, 6,17,17,17,17},
			 {17, 8, 8, 8,17,17,17}};

char dudel[HIGHT][WIDTH];

char dude1[HIGHT][WIDTH]={{17,12,12,12,17,17,17},
			  { 8,12,12,12,12,12,17},
			  {91,91,91, 9,91,17,17},
			  {17,91,91,91,17,17,17},
			  {17,91,17,17,17,17,17},
			  {17,04,12,17,23,23,23},
			  {17,12,04,91,24,17,17},
			  {17,34,34,17,17,17,17},
			  {17,34,34,17,17,17,17},
			  {17,34,17,34,17,17,17},
			  { 6, 6,17, 6, 6,17,17},
			  { 8, 8, 8, 8, 8, 8,17}};

char dudel1[HIGHT][WIDTH];


char dudej[HIGHT][WIDTH]={{17,12,12,12,17,17,17},
			  { 8,12,12,12,12,12,17},
			  {91,91,91, 9,91,17,17},
			  {17,91,91,91,17,17,17},
			  {17,91,17,17,17,17,17},
			  {17,04,12,17,23,23,23},
			  {17,12,04,91,24,17,17},
			  {17,34,34,17,17,17,17},
			  {17,34,34,34,17,17,17},
			  { 8, 6,34,34,17,17,17},
			  { 8, 6,17, 6, 6,17,17},
			  { 8,17,17, 8, 8, 8,17}};

char dudelj[HIGHT][WIDTH];

char dudead[HIGHT][WIDTH]={{17,19,19,17,17,17,19},
			   {19,21,20,19,17,19,19},
			   {17,20,19,17,19,20,19},
			   {17,19,17,17,19,21,17},
			   {17,12,12,12,17,19,17},
			   { 8,12,12,12,12,12,17},
			   {91,91,91, 9,91,17,17},
			   {17,91,91,91,17,17,17},
			   {17,91,17,17,17,17,17},
			   {17,04,12,17,23,23,23},
			   {17,12,04,91,24,17,17},
			   {17,34,34,17,17,17,17}};

char dudead1[HIGHT][WIDTH]={{17,21,21,17,17,17,17},
			   {21,22,22,21,17,17,17},
			   {21,22,23,17,21,17,17},
			   {17,24,23,21,17,17,17},
			   {21,22,24,21,17,17,17},
			   {21,22,22,21,23,17,17},
			   {17,21,21,17,17,17,17},
			   {17,21,23,17,17,17,17},
			   {17,12,12,12,17,17,17},
			   { 8,12,12,12,12,12,17},
			   {91,91,91, 9,91,17,17},
			   {17,91,91,91,17,17,17}};

char dudead2[HIGHT][WIDTH]={{21,21,21,17,17,21,17},
			   {21,22,23,21,21,21,21},
			   {17,21,22,23,23,22,21},
			   {17,22,23,21,24,21,17},
			   {17,21,22,24,23,22,21},
			   {21,22,23,24,24,21,17},
			   {21,22,23,23,24,17,21},
			   {17,21,22,24,23,21,21},
			   {21,22,23,24,23,21,17},
			   {21,22,22,23,23,21,17},
			   {17,21,21,17,21,17,17},
			   {17,17,17,21,17,17,17}};


char dudeb[HIGHT][WIDTH]={{17,12,12,12,17,17,27},
			 { 8,12,12,12,12,12,26},
			 {91,91,91, 9,91,17,25},
			 {17,91,91,91,15,15,42},
			 {17,91,17,17,17,17,17},
			 {17,04,12,17,17,17,17},
			 {17,12,04,91,17,17,17},
			 {17,34,34,17,17,17,17},
			 {17,34,34,17,17,17,17},
			 {17,34,17,17,17,17,17},
			 {17, 6, 6,17,17,17,17},
			 {17, 8, 8, 8,17,17,17}};

char dudeb1[HIGHT][WIDTH]={{17,12,12,12,17,17,25},
			 { 8,12,12,12,12,12,24},
			 {91,91,91,12,91,17,23},
			 {17,91,91,91,15,15,43},
			 {17,91,17,17,17,17,17},
			 {17,04,12,17,17,17,17},
			 {17,12,04,91,17,17,17},
			 {17,34,34,17,17,17,17},
			 {17,34,34,17,17,17,17},
			 {17,34,17,17,17,17,17},
			 {17, 6, 6,17,17,17,17},
			 {17, 8, 8, 8,17,17,17}};

char dudeb2[HIGHT][WIDTH]={{17,12,12,12,17,17,23},
			 { 8,12,12,12,12,12,24},
			 {91,91,91, 9,91,17,25},
			 {17,91,91,91,15,15,44},
			 {17,91,17,17,17,17,17},
			 {17,04,12,17,17,17,17},
			 {17,12,04,91,17,17,17},
			 {17,34,34,17,17,17,17},
			 {17,34,34,17,17,17,17},
			 {17,34,17,17,17,17,17},
			 {17, 6, 6,17,17,17,17},
			 {17, 8, 8, 8,17,17,17}};

char cube[HIGHT][WIDTH]={{19,19,19,19,19,19,19},
			 {20,20,20,20,20,20,20},
			 {21,21,21,21,21,21,21},
			 {22,22,22,22,22,22,22},
			 {23,23,23,23,23,23,23},
			 {24,24,24,24,24,24,24},
			 {24,24,24,24,24,24,24},
			 {23,23,23,23,23,23,23},
			 {22,22,22,22,22,22,22},
			 {21,21,21,21,21,21,21},
			 {20,20,20,20,20,20,20},
			 {19,19,19,19,19,19,19}};

char capr[HIGHT][WIDTH]={{17,19,19,19,19,19,19},
			 {19,19,20,20,20,20,20},
			 {19,20,21,21,21,21,21},
			 {19,21,22,22,22,22,22},
			 {19,22,23,23,23,23,23},
			 {19,23,24,24,24,24,24},
			 {19,23,24,24,24,24,24},
			 {19,22,23,23,23,23,23},
			 {19,21,22,22,22,22,22},
			 {19,20,21,21,21,21,21},
			 {19,19,20,20,20,20,20},
			 {17,19,19,19,19,19,19}};

char capl[HIGHT][WIDTH]={{17,19,19,19,19,19,19},
			 {19,19,20,20,20,20,20},
			 {19,20,21,21,21,21,21},
			 {19,21,22,22,22,22,22},
			 {19,22,23,23,23,23,23},
			 {19,23,24,24,24,24,24},
			 {19,23,24,24,24,24,24},
			 {19,22,23,23,23,23,23},
			 {19,21,22,22,22,22,22},
			 {19,20,21,21,21,21,21},
			 {19,19,20,20,20,20,20},
			 {17,19,19,19,19,19,19}};

char rock[HIGHT][WIDTH]={{22,23,21,23,24,25,21},
			 {24,23,23,21,24,25,23},
			 {23,23,24,23,21,23,24},
			 {21,23,24,23,22,23,25},
			 {22,21,23,23,21,21,24},
			 {25,22,21,22,23,22,23},
			 {24,23,23,23,24,25,23},
			 {21,25,24,21,23,23,25},
			 {22,24,23,24,25,24,21},
			 {24,23,23,23,23,23,24},
			 {21,23,23,22,24,21,23},
			 {23,21,22,24,25,23,22}};


char brock[HIGHT][WIDTH]={{41,40,41,40,41,40,41},
			  {41,40,41,41,41,41,40},
			  {41,40,136,40,41,136,41},
			  {136,41,136,136,41,136,136},
			  {136,41,136,23,136,21,24},
			  {25,136,21,22,23,22,23},
			  {24,23,23,23,24,25,23},
			  {21,25,24,21,23,23,25},
			  {22,24,23,24,25,24,21},
			  {24,23,23,23,23,23,24},
			  {21,23,23,22,24,21,23},
			  {23,21,22,24,25,23,22}};

char back[HIGHT][WIDTH]={{00,00,00,00,00,00,00},
			 {00,00,00,00,00,00,00},
			 {00,00,00,00,00,00,00},
			 {00,00,00,00,00,00,00},
			 {00,00,00,00,00,00,00},
			 {00,00,00,00,00,00,00},
			 {00,00,00,00,00,00,00},
			 {00,00,00,00,00,00,00},
			 {00,00,00,00,00,00,00},
			 {00,00,00,00,00,00,00},
			 {00,00,00,00,00,00,00},
			 {00,00,00,00,00,00,00}};

char dinoc[HIGHT][WIDTH]={{17,17,12,12,17,17,22},
			  {12,12,12,12,12,17,23},
			  {17,91,91, 9,91,00,24},
			  {17,91,91,91,06,43,17},
			  {17,91,17,17,17,17,17},
			  {17,39,12,17,10,10,17},
			  {17,12,39,91,120,120,17},
			  {17,12,12,17,17,17,17},
			  {17,12,12,12,17,17,17},
			  { 8,23,12,12,17,17,17},
			  { 8,23,17,23,24,17,17},
			  { 8,17,17, 8, 8, 8,17}};

char dinoc1[HIGHT][WIDTH]={{17,17,12,12,17,17,24},
			  {12,12,12,12,12,17,23},
			  {17,91,91, 9,91,00,22},
			  {17,91,91,91,06,42,17},
			  {17,91,17,17,17,17,17},
			  {17,39,12,17,17,17,17},
			  {17,12,39,91,120,120,17},
			  {17,12,12,17,10,10,17},
			  {17,12,12,12,17,17,17},
			  { 8,23,12,12,17,17,17},
			  { 8,23,17,23,24,17,17},
			  { 8,17,17, 8, 8, 8,17}};


char fath[HIGHT][WIDTH]={{17,00,44,44,00,00,17},
			 {00,44,91, 9,91,91,00},
			 {44,44,91,91,40,00,00},
			 {00,00,91,91,91,00,00},
			 {00,39,39,39,39,39,00},
			 {39,39,39,39,39,39,39},
			 {39,136,39,136,39,136,39},
			 {39,39,136,39,136,39,39},
			 {91,39,39,39,39,39,91},
			 {00,39,39,39,39,39,00},
			 {00,39,39,39,39,39,00},
			 {21, 8,39,39,39, 8,21}};

char fath1[HIGHT][WIDTH];

char yipi[HIGHT][WIDTH]={{00,00, 6, 6,00,00,00},
			 {00, 6,91, 9,91,00,00},
			 {00, 6,91,91,00,00,00},
			 {00,00,91,91,91,00,00},
			 {00,00,15,15,00,00,00},
			 {00,00,15,15,00,00,00},
			 {00,00,15,15,91,24,00},
			 {00,00,23,23,00,00,25},
			 {00,00,24,24,00,00,24},
			 {00,00, 6, 6, 6,00,23},
			 {23,23,24,25,24,23,23},
			 {00,12,00,00,00,12,00}};

char yipi1[HIGHT][WIDTH];

char testlogo_orb[HIGHT][WIDTH]={{00,00,00,00,00,00,00},
			 {00,00,00,00,00,00,00},
			 {00,00,46,46,46,00,00},
			 {00,46,47,45,47,46,00},
			 {46,47,45,45,45,47,46},
			 {24,24,24,24,24,24,24},
			 {24,25,26,27,26,25,24},
			 {24,25,26,27,26,25,24},
			 {24,25,26,27,26,25,24},
			 {00,24,26,27,26,24,00},
			 {00,00,24,24,24,00,00},
			 {00,00,00,00,00,00,00}};


char acidc[HIGHT][WIDTH]={{00,46,46,00,00,00,00},
			  {46,45,45,46,00,00,46},
			  {45,45,45,45,46,46,45},
			  {45,44,45,44,45,45,45},
			  {45,45,45,45,45,45,45},
			  {45,45,44,45,45,45,45},
			  {45,45,45,45,45,45,45},
			  {45,45,45,45,44,45,45},
			  {45,45,45,45,45,45,45},
			  {45,44,45,45,45,45,45},
			  {45,45,45,45,45,45,44},
			  {45,45,45,45,45,45,45}};

char acidc1[HIGHT][WIDTH];

char dspike[HIGHT][WIDTH]={{00,00,00,00,00,00,00},
			   {00,00,00,24,00,00,00},
			   {00,00,21,23,21,00,00},
			   {00,21,22,23,22,21,00},
			   {24,21,22,24,22,21,24},
			   {00,21,22,23,22,21,00},
			   {24,21,22,24,22,21,24},
			   {00,21,22,23,22,21,00},
			   {24,21,22,24,22,21,24},
			   {00,21,22,23,22,21,00},
			   {24,21,22,24,22,21,24},
			   {00,21,22,23,22,21,00}};


char dspike1[HIGHT][WIDTH]={{00,00,00,24,00,00,00},
			    {00,00,00,23,00,00,00},
			    {00,00,21,23,21,00,00},
			    {24,21,22,24,22,21,24},
			    {00,21,22,23,22,21,00},
			    {24,21,22,24,22,21,24},
			    {00,21,22,23,22,21,00},
			    {24,21,22,24,22,21,24},
			    {00,21,22,23,22,21,00},
			    {24,21,22,24,22,21,24},
			    {00,21,22,23,22,21,00},
			    {00,21,22,23,22,21,00}};



char level1[LHIGHT][LWIDTH]={{ 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2},
			     { 2,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00, 2},
			     { 2,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00, 2},
			     { 2,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00, 2},
			     { 2,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00, 1,00,00,00, 1,00,00,00,00,00,00,00, 2},
			     { 2,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00, 1,00, 1, 3, 1,00, 1,00,00,00,00,00,00, 2},
			     { 2,00,00,00,00,00,00,00,00, 4, 5,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00, 1,00, 1,00, 1,00, 1,00,00,00,00,00,00, 2},
			     { 2,00,00,00,00, 4, 5,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00, 1, 1, 1,00, 1,00, 1,00,00,00,00,00,00, 2},
			     { 2,00,00,00,00,00,00,00, 4, 1, 1, 5,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00, 1,00, 1,00, 1,00, 1,00,00,00,00,00,00, 2},
			     { 2,00,00,00,00,00,00,00,00,00,00,00, 1,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00, 1,00, 1,00,00, 1,00, 1,00,00,00,00,00, 2},
			     { 2,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00, 3,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00, 2},
			     { 2,00,00,00,00,00,00,00,00,00,00,00, 2, 3, 3, 3, 2,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00, 2},
			     { 2,00,00,00, 2, 2,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00, 2},
			     { 2,00, 4, 1, 1, 2,00,00,00,00,00,00,00,00,00,00, 2,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00, 2},
			     { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2}};
char *blocks[MAXB];
char *dd[3];

blocks[0]=(char *)back;
blocks[1]=(char *)cube;
blocks[2]=(char *)rock;
blocks[3]=(char *)brock;
blocks[4]=(char *)capr;
blocks[5]=(char *)capl;


flipspritey(dude, dudel);
flipspritey(dude1, dudel1);
flipspritey(dudej, dudelj);
flipspritey(acidc, acidc1);
flipspritey(capr, capl);
flipspritey(fath, fath1);
flipspritey(yipi, yipi1);

#ifdef DBG
getch();
#endif




 x=DUDEX;
 y=DUDEY;

 mx=x;
 my=y;

 if(readlevel("level2.map",(char *)level1)){
   printf("Can not open input file. File missing or corupted.\n");
   return 1;
 }


		  //.oO Init Graph mode from here on Oo.\\

  set320();
  loadlevel(blocks,level1);
 putsprite(dude,x,y);
 putsprite(testlogo_orb,0,199-HIGHT);
 putsprite(dinoc,231,48);
 fontinit();

 putmsg(font,"DumbGame Nostalgic DOS game dev.",7,199-HIGHT);


 kbdspeed();

getch();

  for(i=0;i<MGT;i++)
   count[i]=NULL;

  count[0]=&jump_delay;
  count[1]=&dead_delay;
  count[2]=&fall_delay;

  for(i=0;i<MACIDS;i++)
   if(acids[i][0]>=0){
    count[3+i]=&acids[i][0];
   }
   else count[3+i]=NULL;


  for(i=0;i<MSPIKE;i++)
   if(dspikes[i][0]>=0){
    count[3+MACIDS+i]=&dspikes[i][0];
   }
   else count[3+MACIDS+i]=NULL;


  for(i=0;i<MFATH;i++)
   if(fathos[i][0]>=0){
    count[3+MACIDS+MSPIKE+i]=&fathos[i][0];
   }
   else count[3+MACIDS+MSPIKE+i]=NULL;


  oldhandler = getvect(INTR);
  setvect(INTR, handler);
  uppit();

 do{
    oldx=x;
    oldy=y;

    if(kbhit()) keyme=getch();

    switch(keyme){


      case 's': if( ( (temp=get_pix(x+WIDTH,y+(HIGHT-1))) >=0)&&(temp<=10))
		 if( ( (temp=get_pix(x+WIDTH,y)) >=0)&&(temp<=10)){
		  // killsprite(0,x,y);
		   x+=DUDESPEED;
		}
		left=0;
	       //putsprite(dude, x, y);
		break;

      case 'a': if( ( (temp=get_pix(x-1,y+(HIGHT-1))) >=0)&&(temp<=10) )
		 if( ( (temp=get_pix(x-1,y)) >=0)&&(temp<=10) ){
		  //killsprite(0,x,y);
		   x-=DUDESPEED;
		}

		left=1;
	       //putsprite(dudel, x, y);
		break;

      case 'w': if(jump==0) jump=24; break;

      case 't': y=0; break;

      case 'p': pause=1; break;

      case 'q': quit=1;

    }

    keyme=0;

   while(pause){
    putmsg(font,"pAuSE",280,199-HIGHT);
    if(kbhit()){ pause=0; putmsg(font,"     ",280,199-HIGHT);}

   }

/*  Jumping */

   if((jump!=0)&&(fall==0))
    if( (get_pix(x,y-1)==0)&&(get_pix(x+WIDTH-1,y-1)==0)){
     if(jump_delay==0){
     //killsprite(0,x,y);
      y-=1;
    //if(left) putsprite(dudel, x, y);
     //else putsprite(dude, x, y);
      jump_delay=2*eatCPU;
      jump--;
     }
//     else ;//jump_delay--;
    }
    else jump=0;
   else jump=0;


/*  Falling */

   if(jump==0)
    if( (get_pix(x,y+HIGHT)==0)&&(get_pix(x+WIDTH-1,y+HIGHT)==0)){
     fall=1;
     if(fall_delay==0){
      //killsprite(0,x,y);
      y+=1;
      //if(left) putsprite(dudel, x, y);
     //else putsprite(dude, x, y);
      fall_delay=1*eatCPU;
     }
//     else fall_delay--;
    }
    else{ fall_delay=0; fall=0;}


/*  Machines */

   for(i=0;i<MACIDS;i++){
    if(acids[i][0]>=0){
     dead=acid(acidc,acidc1,&acids[i][0],&acids[i][1],acids[i][2],acids[i][3],x,y);
     if(dead) i=MACIDS;
    }
   }


   if(!dead)
    for(i=0;i<MSPIKE;i++){
     if(dspikes[i][0]>=0){
      dead=dspikef(dspike,dspike1,&dspikes[i][0],&dspikes[i][1],dspikes[i][2],dspikes[i][3],x,y);
      if(dead) i=MSPIKE;
     }
    }

   if(!dead)
    for(i=0;i<MFATH;i++){
     if(fathos[i][0]>=0){
      dead=fathf(fath,fath1,&fathos[i][0],&fathos[i][1],fathos[i][2],fathos[i][3],x,y);
      if(dead) i=MFATH;
     }
    }


   if(!dead)
    for(i=0;i<MYIPI;i++){
     if(yipis[i][0]>=0){
      dead=yipif(yipi,yipi1,&yipis[i][0],&yipis[i][1],&yipis[i][2],&yipis[i][3],x,y);
      if(dead) i=MYIPI;
     }
    }

   if(!dead)
    dead=dinof(dinoc,dinoc1,&dinod,&dinos,231,48,x,y);

   if(dead){
    switch(dead){
     case 1  : dd[0]=(char *)dudead;
	       dd[1]=(char *)dudead1;
	       dd[2]=(char *)dudead2;
	       j=0;
	       break;

     case 42:  dd[0]=(char *)dudeb;
	       dd[1]=(char *)dudeb1;
	       dd[2]=(char *)dudeb2;
	       j=10;
	       putmsg(font,"80s Era appropriate ending. Cigarettes kill."
	       ,0,100-HIGHT);
	       break;

     default : dd[0]=(char *)dudead;
	       dd[1]=(char *)dudead1;
	       dd[2]=(char *)dudead2;
	       j=0;
    }

   for(;j>=0;j--)
    for(i=0;i<3;)
     if(dead_delay==0){
       killsprite(0,oldx,oldy);
	putblock(dd[i], oldx, oldy);
       dead_delay=5*eatCPU;
       i++;
     }

     dead_delay=6*eatCPU;
     while(dead_delay);

    dead_delay=0;
    dead=0;
    killsprite(0,oldx,oldy);
    x=mx;
    y=my;
   }

   if((x!=oldx)||(y!=oldy)){
    if(jump||fall){
     killsprite(0,oldx,oldy);
      if(left) putsprite(dudelj, x, y);
      else putsprite(dudej, x, y);

    }
    else{

      if(x!=oldx)
       if(mdelay==0){
	mdelay=2*eatCPU;
	if(ms){ ms=0;}
	else  { ms=1;}
     }
     else { mdelay-=1; }

     killsprite(0,oldx,oldy);
     if(ms){
      if(left) putsprite(dudel, x, y);
	else putsprite(dude, x, y);
     }
     else{
       if(left) putsprite(dudel1, x, y);
	else putsprite(dude1, x, y);
     }
    }

    }

 }while(!quit);

normpit();
setvect(INTR, oldhandler);
kbdnormal();
showpallete();
return 0;
}

